//+------------------------------------------------------------------+
//|                                                    TeaCoffee.mq4 |
//|                                       Copyright 2014, MetaDriver |
//|                  https://login.mql5.com/ru/users/metadriver/news |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaDriver"
#property link      "https://login.mql5.com/ru/users/metadriver/news"
#property version   "1.00"
#property strict
#property script_show_inputs
//--- input parameters
input double   TeaTemperature=1.0;     //   
input double   CoffeeTemperature=0.0;  //   
input int      TeaPartCount=5000;      //   
input int      CoffeePartCount=5000;   //   
input double   TeaVolume=1.0;          //   
input double   CoffeeVolume=1.0;       //   

struct Part  //    
  {
   double t;
   double v;
  };
struct Tprs //    .        
  {
   double t1;
   double t2;
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   Tprs TEnd = RunTprChange(
            TeaTemperature, CoffeeTemperature,
            TeaPartCount,   CoffeePartCount,
            TeaVolume,      CoffeeVolume);
   PrintResults(TEnd);
  }
//+------------------------------------------------------------------+
// 
Tprs RunTprChange(double t1, double t2, int n1, int n2, double v1, double v2)
  {
   Part TeaPart, CoffeePart, TeaParts[], CoffeeParts[];
   TeaPart.t = t1;  TeaPart.v = v1/n1;
   CoffeePart.t = t2;  CoffeePart.v = v2/n2;
   ArrayResize(TeaParts, n1);
   ArrayResize(CoffeeParts, n2);
   //  
   for(int i=0;i<n1;i++)  { TeaParts[i] = TeaPart; }
   for(int i=0;i<n2;i++)  { CoffeeParts[i] = CoffeePart; }
   // *****   *****
   double sVol = TeaPart.v + CoffeePart.v; //    (    )
   for(int i=0;i<n1;i++)
     {
      for(int j=0;j<n2;j++)
        {
         TeaParts[i].t = CoffeeParts[j].t =
           ( TeaParts[i].t * TeaPart.v + CoffeeParts[j].t * CoffeePart.v ) / sVol;
        }
     }
   //  
   Tprs TEnd = {0};
   for(int i=0;i<n1;i++)  { TEnd.t1 += TeaParts[i].t; }
   TEnd.t1 /= n1;
   for(int i=0;i<n2;i++)  { TEnd.t2 += CoffeeParts[i].t; }
   TEnd.t2 /= n2;

   return TEnd;
  } 
//+------------------------------------------------------------------+
//    
void PrintResults(Tprs &ts)
  {
   printf(": t  = %f, t  = %f, n  = %i, n  = %i, v  = %f, v  = %f",
     TeaTemperature, CoffeeTemperature, TeaPartCount, CoffeePartCount, TeaVolume, CoffeeVolume);
   printf(":  t  = %.12f, t  = %.12f", ts.t1, ts.t2);
  }
